<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

function filter_username($your_name, $my_name, $filtered_message)
{
	global $config, $user;
	
	$page_name = substr($user->page['page_name'], 0, strpos($user->page['page_name'], '.'));

	if ($page_name == 'viewtopic')
	{
		// is this a quoted text?
		$filter_start = "<blockquote>";
		$filter_end = "</blockquote>";
		$filter_output = getBetween($filtered_message, $filter_start, $filter_end);
		$find_me = strpos($filter_output, '[me]');
		if ($find_me !== false)
		{
			$find_quoter = strpos($filter_output, '<cite>');
			if ($find_quoter !== false)
			{
				// we have found [me] in a quoted text, replace it with quoted user
				$quoted_name = getBetween($filter_output, "<cite>", "</cite>");
				$quoted_cleaned = str_replace(' ' . $user->lang['WROTE'] . ':', '', $quoted_name);
				$my_name = $quoted_cleaned;
			}
			else
			{
				$my_name = $my_name;
			}
		}
		else
		{
			$my_name = $my_name;
		}
	}
	else
	{
		$my_name = $my_name;
	}
		
	$find = array('[we]', '[me]', '[you]', '[us]');
		$replace = array(
		sprintf($user->lang['FILTER_WE'], $your_name, $my_name),
		$my_name,
		$your_name,
		'<span style="color: red;">' . $config['sitename'] . '</span>',
	);
	$filtered_message = str_replace($find, $replace, $filtered_message);
	
	return $filtered_message;
}

function getBetween($filter_content, $filter_start, $filter_end)
{
	$r = explode($filter_start, $filter_content);
	if (isset($r[1]))
	{
		$r = explode($filter_end, $r[1]);
		return $r[0];
    }
    return '';
}
?>